package programsearchfault;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Caret;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

public class PsfgameMain implements CaretListener{
	public static PsfgameMain gamemain;
	public static JTextPane trueText;
	public static JTextPane falseText;
	public static Clear clearText;
	public static JLabel currentDisplay = new JLabel();
	public static JButton answerButton = new JButton("スタート");
	public static String truthsource;
	public static String nowsource;
	public static final int faultMaxNum = 10;
	public static int selectnum;
	public static int findfault = 0;
	public static int[] faultpos = new int[faultMaxNum];
	public static int mode = 1;
	public static Thread thr = null;
	public static long starttime;
	public static long goaltime;
	public DefaultStyledDocument document = new DefaultStyledDocument();
	String source = new String();
	public void caretUpdate(CaretEvent e) {
		Caret caret = falseText.getCaret();
		selectnum = caret.getDot();
		if (mode == 0)
			color();
	}
	public void color() {
		Caret caret = falseText.getCaret();
		SimpleAttributeSet attribute = new SimpleAttributeSet();
		attribute.addAttribute(StyleConstants.Foreground, Color.BLACK);
		document.setCharacterAttributes(0, document.getLength(), attribute, true);
		attribute.addAttribute(StyleConstants.Foreground, Color.RED);
		StyleConstants.setBackground(attribute, new Color(255, 180, 180));
		document.setCharacterAttributes(caret.getDot(), 1, attribute, true);
		StyleConstants.setBackground(attribute, Color.WHITE);
		for (int i = 0; i < faultMaxNum; i++) {
			if (i < findfault) {
				attribute.addAttribute(StyleConstants.Foreground, Color.GREEN);
				document.setCharacterAttributes(faultpos[i], 1, attribute, true);
				if (selectnum == faultpos[i]) {
					attribute.addAttribute(StyleConstants.Foreground, Color.ORANGE);
					StyleConstants.setBackground(attribute, new Color(255, 180, 180));
					document.setCharacterAttributes(caret.getDot(), 1, attribute, true);
					StyleConstants.setBackground(attribute, Color.WHITE);
				}
			} else if (mode == 1) {
				attribute.addAttribute(StyleConstants.Foreground, Color.RED);
				StyleConstants.setBold(attribute, true);
				StyleConstants.setBackground(attribute, new Color(255, 180, 180));
				document.setCharacterAttributes(faultpos[i], 1, attribute, true);
			}
		}
		StyleConstants.setBackground(attribute, Color.WHITE);
	}
	public void init() {
		Caret caret1 = falseText.getCaret();
		Caret caret2 = trueText.getCaret();
		selectnum = 0;
		sourceLoad();
		findfault = 0;
		for (int i = 0; i < faultMaxNum; i++) {
			faultpos[i] = -1;
		}
		//color();
		caret1.setDot(0);
		caret2.setDot(0);
		currentDisplay.setText(String.format("残りエラー = %d", faultMaxNum - findfault));
		mode = 0;
		starttime = System.currentTimeMillis();
	}
	public char charChange(char input) {
		int charnum = 0, randomnum = 0;
		char[][] changeCharList = new char[][]{
				{'o', 'd', 'q', 'b', 'k'},//a
				{'p', 'q', 'd', 'B', 'r'},//b
				{'e', 'C', 'o', 'r', 'u'},//c
				{'q', 'b', 'p', 'k', 'a'},//d
				{'c', 'o', 'r', 'g', 'E'},//e
				{'F', 't', 'p', 'k', 'Y'},//f
				{'q', 'e', '%', 'u', 'w'},//g
				{'b', 'k', 'd', 'L', 'd'},//h
				{';', '1', 'I', '|', 'J'},//i
				{'J', 'U', 'u', 'd', 'R'},//j
				{'h', 'b', 'n', 'd', 'G'},//k
				{'|', '/', 'i', 'L', 'J'},//l
				{'n', 'w', 'M', 'x', 'v'},//m
				{'r', 'u', 'm', 'o', 'q'},//n
				{'O', '0', 'u', 'n', 'r'},//o
				{'b', 'd', 'q', 'o', 'P'},//p
				{'d', 'p', 'b', 'o', 'Q'},//q
				{'n', 'u', 'o', 'y', 'l'},//r
				{'g', 'S', '&', '%', 'c'},//s
				{'f', 'L', 'T', 'r', 'c'},//t
				{'v', 'n', 'o', 'q', 'U'},//u
				{'u', 'n', 'y', 'o', 'V'},//v
				{'v', 'W', 'm', 'x', 'z'},//w
				{'X', '*', 'k', 'v', 'm'},//x
				{'t', 'Y', 'v', 'y', 'q'},//y
				{'Z', 's', 'x', 'y', 'n'},//z
				{'V', 'W', 'M', '^', 'a'},//A
				{'R', 'P', 'b', 'g', 'D'},//B
				{'O', 'G', 'c', 'Q', 'T'},//C
				{'B', 'P', 'R', 'O', 'd'},//D
				{'F', '[', 'C', 'R', 'P'},//E
				{'E', '[', 'C', 'R', 'P'},//F
				{'C', 'Q', 'O', 'E', 'c'},//G
				{'h', 'X', 'K', 'F', 'f'},//H
				{'|', 'i', '1', '/', '!'},//I
				{'j', 'I', 'U', 'L', ')'},//J
				{'k', 'H', 'E', 'h', 'c'},//K
				{'I', '|', 'J', 'k', 'h'},//L
				{'H', 'W', 'm', 'N', 'n'},//M
				{'A', 'V', 'M', 'X', 'U'},//N
				{'0', 'o', 'Q', 'C', 'D'},//O
				{'R', 'B', 'b', 'p', 'D'},//P
				{'O', '0', 'C', 'o', 'D'},//Q
				{'P', 'B', 'K', 'p', 'b'},//R
				{'&', 's', '5', 'Z', '8'},//S
				{'Y', '+', 'I', 'V', '\\'},//T
				{'V', 'C', 'O', '0', 'u'},//U
				{'U', 'v', 'D', 'y', 'N'},//V
				{'M', 'N', 'X', 'w', '#'},//W
				{'K', 'H', 'Y', '*', 'x'},//X
				{'T', 'y', 'V', 'N', 'W'},//Y
				{'2', 'z', '%', '/', 'N'},//Z
				{'O', 'o', 'Q', 'C', 'G'},//0
				{'I', '|', '!', 'i', 'L'},//1
				{'Z', '%', 'z', '3', 'R'},//2
				{'8', '}', 'E', 'H', '9'},//3
				{'R', 'K', 'N', 'P', 'q'},//4
				{'S', 's', '9', '6', 'P'},//5
				{'b', 'h', '5', 'L', 'E'},//6
				{'/', 'T', 'Y', '9', 'V'},//7
				{'3', '6', '9', '%', 'g'},//8
				{'q', '6', '8', '3', 'R'},//9
				{'t', 'f', '*', '#', 'k'},//+
				{'t', 'f', '_', 'H', 'v'},//-
				{'#', '+', 'k', 'x', 'y'},//*
				{'|', 'M', 'I', 'Y', 'W'},///
				{'-', '#', 'F', 'P', 'E'},//=
				{'D', '}', ')', ']', 'P'},//>
				{'C', '{', '(', '[', 'G'},//<
				{'%', 'K', 'S', 'B', 'R'},//&
				{'I', '1', 'i', ';', ':'},//|
				{'i', ';', ':', '1', '|'},//!
				{'~', '\'', '"', 'P', '('},//^
				{'^', '\'', '"', 'R', '['},//~
				{'^', '~', '"', 'K', '{'},//'
				{'^', '~', '\'', 'E', ']'},//"
				{'|', 'I', '1', '!', '#'},//\
				{';', 'i', '!', 'I', '1'},//:
				{':', 'i', '!', 'I', '1'},//;
				{'Z', '/', '8', '2', '&'},//%
				{'+', '*', '&', '%', 'O'},//#
				{'[', '{', 'C', 'G', ')'},//(
				{']', '}', '>', 'Y', '('},//)
				{'{', '(', '<', 'E', ']'},//[
				{'}', ')', '>', 'Z', '['},//]
				{'(', '[', '<', 'E', '}'},//{
				{')', ']', '>', 'Z', '{'},//}
				{',', '_', '!', '?', ':'},//.
				{'.', '_', '!', '?', ';'},//,
				{'.', ',', '-', '!', '?'},//_
				{'!', ';', ':', '8', '9'},//?
				//{'', '', '', '', ''},//

		};
		if (input >= 'a' && input <= 'z') {
			charnum = input - 'a';
		} else if (input >= 'A' && input <= 'Z') {
			charnum = input - 'A' + 26;
		} else if (input >= '0' && input <= '9') {
			charnum = input - '0' + 52;
		} else {
			switch (input) {
			case '+':
				charnum = 62;
				break;
			case '-':
				charnum = 63;
				break;
			case '*':
				charnum = 64;
				break;
			case '/':
				charnum = 65;
				break;
			case '=':
				charnum = 66;
				break;
			case '>':
				charnum = 67;
				break;
			case '<':
				charnum = 68;
				break;
			case '&':
				charnum = 69;
				break;
			case '|':
				charnum = 70;
				break;
			case '!':
				charnum = 71;
				break;
			case '^':
				charnum = 72;
				break;
			case '~':
				charnum = 73;
				break;
			case '\'':
				charnum = 74;
				break;
			case '"':
				charnum = 75;
				break;
			case '\\':
				charnum = 76;
				break;
			case ':':
				charnum = 77;
				break;
			case ';':
				charnum = 78;
				break;
			case '%':
				charnum = 79;
				break;
			case '#':
				charnum = 80;
				break;
			case '(':
				charnum = 81;
				break;
			case ')':
				charnum = 82;
				break;
			case '[':
				charnum = 83;
				break;
			case ']':
				charnum = 84;
				break;
			case '{':
				charnum = 85;
				break;
			case '}':
				charnum = 86;
				break;
			case '.':
				charnum = 87;
				break;
			case ',':
				charnum = 88;
				break;
			case '_':
				charnum = 89;
				break;
			case '?':
				charnum = 90;
				break;
			}
		}
		randomnum = ((int)(50.0 * Math.random())) % 5;
		return changeCharList[charnum][randomnum];
	}

	public void title() {
		falseText.setText("プログラム間違い探しゲーム\n左右に表示されるプログラムに文字の違いが10個あります。"
				+ "見つけたらその部分をクリックして(クリックしたところは赤くなります)、エラー発見ボタンを押して下さい。"
				+ "間違いであれば残り間違い数が減りオレンジに変わります。全て見つけられるかな？");
		trueText.setText("↑のスタートボタンでスタート。降参するときは解答表示ボタンを押して下さい。");
	}


	public void sourceLoad() {
		int num = 1;
		String liner;
		try {
			StringBuilder sb;
			SimpleAttributeSet attribute = new SimpleAttributeSet();
			InputStream is = getClass().getResourceAsStream("source.txt");
			InputStreamReader in = new InputStreamReader(is);
			BufferedReader filesource = new BufferedReader(in);
			ArrayList<String> listfalse = new ArrayList<String>();
			ArrayList<String> listtruth = new ArrayList<String>();
			while ((liner = filesource.readLine()) != null) {
				listfalse.add(liner);
				listtruth.add(liner);
			}
			for (int i = 0; i < faultMaxNum; i++) {
				int j, k;
				String temp;
				do {
					j = (int)(Math.random() * (double)listfalse.size());
					k = (int)(Math.random() * (double)listfalse.get(j).length());
					if (j == listfalse.size() || k == listfalse.get(j).length())
						continue;
					if (listtruth.get(j).charAt(k) == ' ' || listtruth.get(j).charAt(k) == '\n'
							|| listtruth.get(j).charAt(k) == '\t')
						continue;
					if (listfalse.get(j).charAt(k) != listtruth.get(j).charAt(k))
						continue;
					break;
				} while (true);
				sb = new StringBuilder(listfalse.get(j));
				sb.setCharAt(k, charChange(listfalse.get(j).charAt(k)));
				listfalse.set(j, sb.toString());
			}
			source = "";
			for (Iterator<String> line = listtruth.iterator(); line.hasNext(); ){
				source += String.format("%3d: ", num);
				source += line.next();
				if (line.hasNext()) {
					source += "\n";
					num++;
				}
			}
			truthsource = source;
			source = "";
			num = 1;
			for (Iterator<String> line = listfalse.iterator(); line.hasNext(); ){
				source += String.format("%3d: ", num);
				source += line.next();
				if (line.hasNext()) {
					source += "\n";
					num++;
				}
			}
			nowsource = source;
			document = new DefaultStyledDocument();
			falseText.setDocument(document);
			attribute.addAttribute(StyleConstants.Foreground, Color.BLACK);
			document.insertString(0, nowsource, attribute);
			trueText.setText(truthsource);

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		catch (IOException e) {
			System.err.println("IOException" + e.toString());
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
	}
	public void judge() {
		StringBuilder sb = new StringBuilder(nowsource);
		if (mode != 0)
			return;
		if (selectnum >= nowsource.length())
			return;
		if (nowsource.charAt(selectnum) != truthsource.charAt(selectnum)) {
			faultpos[findfault] = selectnum;
			findfault++;
			sb.setCharAt(selectnum, truthsource.charAt(selectnum));
			nowsource = sb.toString();
		}
	}

	class JudgeAction implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (mode == 0) {
				gamemain.judge();
				gamemain.color();
				currentDisplay.setText(String.format("残りエラー = %d", faultMaxNum - findfault));
				if (faultMaxNum - findfault == 0) {
					goaltime = System.currentTimeMillis();
					mode = 2;
					answerButton.setText("リトライ");
					currentDisplay.setText(String.format("ゲームクリア！おめでとう！\n かかった時間･･･%.3f秒",
							(goaltime - starttime)/1000.0));
					clearText.setVisible(true);
				}
			}
		}
	}

	class AnswerAction implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			int j = findfault;
			if (mode == 0) {
				for (int i = 0; i < nowsource.length(); i++) {
					if (nowsource.charAt(i) != truthsource.charAt(i)) {
						faultpos[j] = i;
						j++;
					}
				}
				mode = 1;
				color();
				currentDisplay.setText(String.format("見つけられなかったエラー = %d", j - findfault));
				answerButton.setText("やり直す");
			} else if (mode == 1) {
				answerButton.setText("解答表示");
				currentDisplay.setText(String.format("残りエラー = %d", faultMaxNum));
				gamemain.init();
			} else if (mode == 2) {
				clearText.setVisible(false);
				answerButton.setText("解答表示");
				currentDisplay.setText(String.format("残りエラー = %d", faultMaxNum));
				gamemain.init();
			}
		}
	}

	class Clear extends JTextPane implements Runnable{
		public final String[] AA =
			{
				" K        K            CCCC             SSSS  ",
				" K      K            C          C       S            S ",
				" K    K            C                   S       ",
				" K  K              C                      SS     ",
				" KK K            C                           SSS  ",
				" K      K          C                                   S ",
				" K        K          C          C     S           S  ",
				" K          K          CCCC          SSSS   ",
				"                             ",
				"                 Congratulation!!      ",
				"",
				"",
				"",
				"",
				""
			};
		public String[] clearDisplay = new String[15];
		public String displayString = new String();
		private int count = 1;
		public void run() {
			while (true) {
				if (mode == 2) {
					displayString = "↓プログラム実行結果↓\n";
					for (int i = 0; i < 15; i++) {
						clearDisplay[i] = "";
					}
					for (int j = 0; j < count; j++) {
						try {
							clearDisplay[15 - count + j] = AA[j];
						} catch (ArrayIndexOutOfBoundsException e) {
							System.err.println(String.format("%d, %d", 15-count+j, j));
						}
					}
					for (int k = 0; k < 15; k++) {
						displayString = displayString + clearDisplay[k] + "\n";
					}
					clearText.setText(displayString);
					if (count < 15) {
						count++;
					}
				} else {
					displayString = "↓プログラム実行結果↓\n";
					clearText.setText(displayString);
					count = 1;
				}
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}
			}
		}
	}

	public Component createComponents() {
		JButton judgeButton = new JButton("エラー発見!");
		JLabel lfalse = new JLabel("間違ったプログラム");
		JLabel ltruth = new JLabel("見本");
		JudgeAction judgeListener = new JudgeAction();
		AnswerAction answerListener = new AnswerAction();
		judgeButton.addActionListener(judgeListener);
		answerButton.addActionListener(answerListener);
		trueText = new JTextPane();
		falseText = new JTextPane(document);
		clearText = new Clear();
		trueText.setEditable(false);
		falseText.setEditable(false);
		JPanel mainPane = new JPanel();
		JPanel subPane = new JPanel();
		JPanel falsetextPane = new JPanel();
		JPanel truthtextPane = new JPanel();
		JPanel textPane = new JPanel();
		falseText.addCaretListener(this);
		trueText.setPreferredSize(new Dimension(700,600));
		trueText.setVisible(true);
		JScrollPane scrollPaneT = new JScrollPane(trueText);
		scrollPaneT.createVerticalScrollBar();
		scrollPaneT.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPaneT.setSize(400,600);
		clearText.setSize(400,600);
		clearText.setVisible(false);
		JScrollPane scrollPaneF = new JScrollPane(falseText);
		falseText.setPreferredSize(new Dimension(700,600));
		scrollPaneF.createVerticalScrollBar();
		scrollPaneF.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPaneF.setSize(400,600);
		falsetextPane.setLayout(new BoxLayout(falsetextPane, BoxLayout.Y_AXIS));
		falsetextPane.add(lfalse);
		falsetextPane.add(scrollPaneF);
		truthtextPane.setLayout(new BoxLayout(truthtextPane, BoxLayout.Y_AXIS));
		truthtextPane.add(ltruth);
		truthtextPane.add(scrollPaneT);
		truthtextPane.add(clearText);
		textPane.setLayout(new BoxLayout(textPane, BoxLayout.X_AXIS));
		textPane.add(falsetextPane);
		textPane.add(truthtextPane);
		subPane.setLayout(new BoxLayout(subPane, BoxLayout.X_AXIS));
		subPane.add(judgeButton);
		subPane.add(currentDisplay);
		subPane.add(answerButton);
		mainPane.setLayout(new BoxLayout(mainPane, BoxLayout.Y_AXIS));
		mainPane.add(subPane);
		mainPane.add(textPane);
		return mainPane;
	}

	public static void main(String[] arg) {
		JFrame frame = new JFrame("Program Error Search Game");
		gamemain = new PsfgameMain();
		Component contents = gamemain.createComponents();
		frame.getContentPane().add(contents, BorderLayout.CENTER);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setBounds(10,10, 1450, 800);
		frame.setVisible(true);
		gamemain.title();
		if (thr == null) {
			thr = new Thread(gamemain.new Clear());
		}
		thr.start();
	}
}